// C Source File
// Created 05/13/2003; 4:39:54 PM

#define USE_TI89              // Compile for TI-89

// #define OPTIMIZE_ROM_CALLS // Use ROM Call Optimization

#define MIN_AMS 100           // Compile for AMS 1.00 or higher

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

short height[20];
short speed[20];
short count[20];
short delay=1;
short x=80;
// Sprite definitions
static unsigned char ice_2[] = {
	0b11111111,
	0b00111100,
};

static unsigned char ice_1[] = {
	0b11111111,
	0b01000010,
	0b00111100
};

static unsigned char ice_0[] = {
	0b11111111,
	0b11111111,
	0b10000011,
	0b10000011,
	0b01000110,
	0b01000110,
	0b01000110,
	0b00101100,
	0b00101100,
	0b00101100,
	0b00011000,
	0b00011000,
	0b00010000,
	0b00010000
};

static unsigned char man[] = {
	0b00111000,
	0b01000100,
	0b01000100,
	0b01000100,
	0b00111000,
	0b00010000,
	0b00010000,
	0b01111100,
	0b00010000,
	0b00010000,
	0b00101000,
	0b01000100,
};
static unsigned short dead[] = {
	0b0011100000000100,
	0b0100010001001000,
	0b0101011001010000,
	0b0100010101100000,
	0b0011100011100000,
	0b0000001100111100
};

short menu(short level)
{
	/*
		short menu()
		Display a game menu
		return 0 for quit or 1..5 for level to start 
	*/
	//short level=3;	//set in parameter
	short ret=0;
	short k;
	char run;
	
	clrscr();
	run = TRUE;
	//level = 3;
	FontSetSys(F_8x10);
	DrawLine( 10,  4,149,  4,A_NORMAL);
	DrawLine( 10, 19,149, 19,A_NORMAL);
	DrawLine( 10,  4, 10, 19,A_NORMAL);
	DrawLine(149,  4,149, 19,A_NORMAL);
	DrawStr(20,7,"Avalanch v0.1",A_NORMAL);
	FontSetSys(F_4x6);
	DrawStr(10,22,"Steve Cavilia",A_NORMAL);
	DrawStr(10,28,"stuuf13t@cox.net",A_NORMAL);
	FontSetSys(F_8x10);
	DrawStr(10,38,"LEVEL:  ",A_NORMAL);
	DrawChar(66,38,'0'+level,A_NORMAL);
	DrawStr(10,56,"START",A_NORMAL);
	DrawStr(10,74,"QUIT",A_NORMAL);
	FontSetSys(F_6x8);
	DrawStr(60,56,"Enter",A_NORMAL);
	DrawStr(60,74,"Esc",A_NORMAL);
	FontSetSys(F_8x10);
	
	while (run == TRUE)
	{
		idle();
		k = ngetchx();
		if (k == KEY_UP && level < 5)
		{
			DrawChar(66,38,'0'+level,A_XOR);
			level++;
			DrawChar(66,38,'0'+level,A_NORMAL);
		}
		if (k == KEY_DOWN && level > 1)
		{
			DrawChar(66,38,'0'+level,A_XOR);
			level--;
			DrawChar(66,38,'0'+level,A_NORMAL);
		}
		if (k == KEY_ENTER) {run = FALSE; ret = level;}
		if (k == KEY_ESC) {run = FALSE; ret = 0;}
	}
	
	return ret;
}

// Main Function
void _main(void)
{
	int i;
	short k;
	short run;
	short game;
	//short clock = delay;
	int new_h;
	char buffer[20];
	short level=3;
	short a=3,b=2,c=6,d=8; //control random conditions by level
	short s1,s2;	//scoring, levels

	short score1;	//scoring note: score1 is incremented
	int   score2; //on timer, icicle reset(depending on speed)
	short scorek;	//when score1 > k (depends on diff) score2 increments
	
	game = TRUE;
	while (game)
	{
	level = menu(level);
	
	switch (level)
	{
		case 0:
		game = FALSE;
		break;
		case 1:
		a=2; b=1; c=12; d=10;
		s1=0; s2=0;
		break;
		case 2:
		a=3; b=1; c=9; d=8;
		s1=1; s2=0;
		break;
		case 3:
		a=3; b=2; c=8; d=8;
		s1=1; s2=1;
		break;
		case 4:
		a=4; b=2; c=5; d=8;
		s1=2; s2=2;
		break;
		case 5:
		a=4; b=4; c=4; d=6;
		s1=3; s2=3;
		break;
	}
	x=80;
	randomize();
	clrscr();
	for (i=0;i<20;i++)
	{
		height[i] = -2;
		speed[i] = rand()%16+8;
		count[i] = 0;
	}
	run = TRUE;
	
	score1 = 0;
	score2 = 0;
	scorek = 4;

	Sprite8(x,88,12,man,LCD_MEM,SPRT_XOR);

	OSFreeTimer(6);
	OSRegisterTimer(6, delay);
	if (game == TRUE) while (run == TRUE)
	{
		OSTimerRestart(6);
		for (i=0;i<20;i++)
		{
			new_h = height[i];
			if (height[i] == -2)
			{
				if (count[i] == 0) Sprite8(i*8,0,2,ice_2,LCD_MEM,SPRT_XOR);
				count[i]++;
					if (count[i] == speed[i])
				{
					new_h = -1;
					count[i] = 0;
					Sprite8(i*8,0,2,ice_2,LCD_MEM,SPRT_XOR);
					Sprite8(i*8,0,3,ice_1,LCD_MEM,SPRT_XOR);
				}
			}
			if (height[i] == -1)
			{
				count[i]++;
				if (count[i] == speed[i])
				{
					new_h = 0;
					count[i] = 0;
					speed[i] = rand()%a+b;
					//Sprite8(i*8,0,3,ice_2,LCD_MEM,SPRT_XOR);
					Sprite8(i*8,0,3,ice_1,LCD_MEM,SPRT_XOR);
					//Sprite8(i*8,0,14,ice_0,LCD_MEM,SPRT_XOR);
				}
			}
			if (height[i] >= 0 && height[i] < 85)
			{
				//if (count[i] == speed[i])
				//{
					new_h = height[i]+speed[i];
					if (height[i] > 0) Sprite8(i*8,height[i],14,ice_0,LCD_MEM,SPRT_XOR);
					if (height[i] == 0) Sprite8(i*8,new_h,14,ice_0,LCD_MEM,SPRT_XOR);
					if (height[i] > 0) Sprite8(i*8,new_h,14,ice_0,LCD_MEM,SPRT_XOR);
				//}
			}
			if (height[i] >= 85)
			{
				Sprite8(i*8,height[i],14,ice_0,LCD_MEM,SPRT_XOR);
				new_h = -2;
				if (abs(x-i*8)<20) score1+=speed[i]+s2;
				speed[i] = rand()%c+d;
			}
			height[i] = new_h;
		}
		//if (ngetchx() == KEY_ESC) run = FALSE;
		
		while (!OSTimerExpired(6))idle();
		score1+=s1;
		//while (clock > 0)
		//clock--;
		//clock = delay;
		
		if (_keytest(RR_ESC)) {run = FALSE;}

		if (_keytest(RR_LEFT) && x > 1)
		{
			Sprite8(x,88,12,man,LCD_MEM,SPRT_XOR);
			x-=2;
			Sprite8(x,88,12,man,LCD_MEM,SPRT_XOR);
		}
		if (_keytest(RR_RIGHT) && x < 152)
		{
			Sprite8(x,88,12,man,LCD_MEM,SPRT_XOR);
			x+=2;
			Sprite8(x,88,12,man,LCD_MEM,SPRT_XOR);
		}
		
		if (height[(x+1)/8] >= 74 || height[(x+5)/8] >= 74)
		{
			 run = FALSE;
		}
		//if (score1 > scorek) {score2++; score1 = 0;}
		
	}
	//Game Over...
	if (game == TRUE){
	GKeyFlush();
	Sprite8(x,88,12,man,LCD_MEM,SPRT_XOR);
	Sprite16(x,92,6,dead,LCD_MEM,SPRT_XOR);
	DrawLine(  8, 40,152, 40,A_NORMAL);
	DrawLine(152, 40,152, 60,A_NORMAL);
	DrawLine(  8, 60,152, 60,A_NORMAL);
	DrawLine(  8, 40,  8, 60,A_NORMAL);
	ScrRectFill(&(SCR_RECT){{0,0,159,99}},&(SCR_RECT){{9,41,151,59}},A_REVERSE);
	FontSetSys(F_8x10);
	sprintf(buffer,"Score: %8d",score1);
	DrawStr(12,45,buffer,A_NORMAL);
	run = TRUE;
	while (run == TRUE)
	{
		idle();
		k = ngetchx();
		if (k == KEY_ENTER || k == KEY_ESC || k == KEY_CLEAR) run = FALSE;
	}}
	}
	OSFreeTimer(6);
}
